<template>
  <v-container>
    <v-layout row wrap class="justify-center">
      <v-flex xs12 sm8 md6 lg5 xl4>
        <v-layout row class="justify-space-between align-baseline">
          <p class="headline">Please pick a dataset</p>
          <p class="headline font-weight-bold text-xs-center">or</p>
          <div>
            <upload-dialog />
          </div>
        </v-layout>
        <v-card
          v-for="dataset in datasetHistory"
          :key="dataset.id"
          class="my-3 pa-2 pl-4"
        >
          <v-layout row class="align-center">
            <v-flex grow>
              <span class="font-weight-bold">Name:</span>
              {{ dataset.filename }}
              <br />
              <span class="font-weight-bold">Added:</span>
              {{ getTime(dataset.timestamp) }}
            </v-flex>
            <v-flex shrink>
              <v-btn
                fab
                outline
                color="success"
                v-show="dataset.isParsed"
                @click="
                  setCurrentDatasetId({
                    id: dataset.id,
                    name: dataset.filename
                  })
                "
              >
                <v-icon>chevron_right</v-icon>
              </v-btn>
              <div v-show="!dataset.isParsed" class="pr-3">
                <span class="primary--text pr-2">parsing...</span>
                <v-progress-circular indeterminate color="primary" />
              </div>
            </v-flex>
          </v-layout>
        </v-card>
      </v-flex>
    </v-layout>
  </v-container>
</template>

<script>
import { mapState } from "vuex";
import moment from "moment";

import UploadDialog from "../components/UploadDialog";

export default {
  components: {
    UploadDialog
  },
  methods: {
    getTime(timestamp) {
      if (timestamp) {
        const { seconds } = timestamp;
        return moment.unix(seconds).fromNow();
      }
    },
    setCurrentDatasetId({ id, name }) {
      this.$store.commit("setCurrentDatasetId", { id, name });
      this.$router.push("/visualisation");
    }
  },
  computed: {
    ...mapState(["datasetHistory"])
  },

  created() {
    this.$store.dispatch("bindDatasetHistoryRef");
  }
};
</script>
